package de.hdm_stuttgart.mi.sd1.test.task2;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.task2.Sentence;

import de.hdm_stuttgart.mi.sd1.test.ignore_me.ObjectWrapper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_Sentence extends ExaminationTestDefaults {

  @Test @Marking(points = 5) public void test_100_empty() {
    {
      final ObjectWrapper<Sentence> s = new ObjectWrapper<>(Sentence.class, "");
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfDigits"));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters"));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters", true));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters", false));
    }
    {
      final ObjectWrapper<Sentence> s = new ObjectWrapper<>(Sentence.class, "    ");
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfDigits"));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters"));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters", true));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters", false));
    }
  }
  @Test @Marking(points = 5) public void test_120_justDigits() {
    {
      final ObjectWrapper<Sentence> s = new ObjectWrapper<>(Sentence.class, "   3 ");
      Assert.assertEquals(1, (int) s.invoke(int.class, "getNumberOfDigits"));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters"));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters", true));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters", false));
    }
    {
      final ObjectWrapper<Sentence> s = new ObjectWrapper<>(Sentence.class, "425");
      Assert.assertEquals(3, (int) s.invoke(int.class, "getNumberOfDigits"));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters"));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters", true));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters", false));
    }
    {
      final ObjectWrapper<Sentence> s = new ObjectWrapper<>(Sentence.class, " 3 54   112  ");
      Assert.assertEquals(6, (int) s.invoke(int.class, "getNumberOfDigits"));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters"));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters", true));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters", false));
    }
  }
  @Test @Marking(points = 5) public void test_200_justLetter() {
    {
      final ObjectWrapper<Sentence> s = new ObjectWrapper<>(Sentence.class, " x  ");
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfDigits"));
      Assert.assertEquals(1, (int) s.invoke(int.class, "getNumberOfLetters"));
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfLetters", true));
      Assert.assertEquals(1, (int) s.invoke(int.class, "getNumberOfLetters", false));
    }
    {
      final ObjectWrapper<Sentence> s = new ObjectWrapper<>(Sentence.class, "Just another day in Paradise");
      Assert.assertEquals(0, (int) s.invoke(int.class, "getNumberOfDigits"));
      Assert.assertEquals(24, (int) s.invoke(int.class, "getNumberOfLetters"));
      Assert.assertEquals(2, (int) s.invoke(int.class, "getNumberOfLetters", true));
      Assert.assertEquals(22, (int) s.invoke(int.class, "getNumberOfLetters", false));
    }
  }
  @Test @Marking(points = 5) public void test_300_mixed() {
    {
      final ObjectWrapper<Sentence> s = new ObjectWrapper<>(Sentence.class, " 50 Ways to leave your lover");
      Assert.assertEquals(2, (int) s.invoke(int.class, "getNumberOfDigits"));
      Assert.assertEquals(20, (int) s.invoke(int.class, "getNumberOfLetters"));
      Assert.assertEquals(1, (int) s.invoke(int.class, "getNumberOfLetters", true));
      Assert.assertEquals(19, (int) s.invoke(int.class, "getNumberOfLetters", false));
    }
  }
}
